#include <iostream>
#include <vector>
#include <set>
#include <utility>

using namespace std;

int main()
{
    int n, m;
    cin >> n >> m;

    set<pair<int, int>> intervals;
    intervals.insert({-2, -2});   // hack na krajní prvky
    intervals.insert({n+2, n+2}); // ve vyhledávacím stromě
    for (int i=0; i<m; i++) {
        int start, end;
        cin >> start >> end;
        vector<pair<int, int>> to_delete;

        bool skip = false;
        if (intervals.size()) {
            auto left=intervals.lower_bound({start, end});
            auto right=intervals.lower_bound({start, end}); right--;
            while (true) {
                if ((left->first <= start && end <= left->second) || (right->first <= start && end <= right->second)) {
                    skip = true; // uvnitř jiného intervalu - nic neděláme
                    break;
                } else if (end >= left->first - 1) {
                    end = max(end, left->second); // dotýká se intervalu napravo - spojíme
                    to_delete.push_back({left->first, left->second});
                    left++;
                } else if (start <= right->second + 1) {
                    start = min(start, right->first); // dotýká se intervalu nalevo - spojíme
                    to_delete.push_back({right->first, right->second});
                    if (right == intervals.begin()) break;
                    right--;
                } else {
                    break; // nedotýká se dalších intervalů - jen ho přidáme
                }
            }
            for (auto x: to_delete) {
                intervals.erase(x); // smažeme překryv
            }
        }

        if (!skip) intervals.insert({start, end});
        cout << intervals.size() - 2 << endl; // pozor máme dva intervaly navíc kvůli našem hacku
    }
}
